#!/usr/bin/perl -w

#Nisus Macro Block
#source front
#destination new
#text as rtf
#End Nisus Macro Block

# Modified 04.11.08.
# Modified 06.05.08.

use strict;
use warnings;

local undef $/;

# my $filepath = "/Volumes/myDocument/Users/ni/Desktop/test_things/NWE_rtf2TeX/testfiles/Martin_trad.rtf";
# open(IN, $filepath) || die ("Couldn't open file $filepath: $!");
# 
# $_ = <IN>;

$_ = <STDIN>;

my $footnote_style = q ~{\s00 \nisusnoteplacement0 \nisusreferencestyle11 \sbasedon22 {\*\nsmpltxt Footnotes appear at the bottom of each page. (Click to edit this sample text.)}
footnote text;}~;
my $footnote_ref_style = q ~{\*\cs00 {\*\nsmpltxt The quick brown fox jumped over the lazy dogs.}
\super footnote reference;}~;

my $endnote_style = q ~{\s00 \nisusnoteplacement2 \nisusreferencestyle11 \sbasedon22 {\*\nsmpltxt Sample text for Foot/End Notes Style}
endnote text;}~;
my $endnote_ref_style = q ~{\*\cs00 {\*\nsmpltxt The quick brown fox jumped over the lazy dogs.}
\super endnote reference;}~;


my ($rtfheader, $rtfdata) = $_ =~ /^(.+?)({\\header.+)$/s;
if (! $rtfheader) {
	($rtfheader, $rtfdata) = $_ =~ /^(.+?)({\\footer.+)$/s;
	if (! $rtfdata) {
		($rtfheader, $rtfdata) = $_ =~ /^(.+?)(\\pard.+)$/s;
	}
}

my ($rtf_firstheader, $fonttbl, $rtf_fonttble_footer) = $rtfheader =~ /^(\{\\rtf1.+?\{\\fonttbl )(\{\\f0.+?;\})([\n\r]?\})/s;

my $stylesheet = &extract_rtf_token ("stylesheet", $rtfheader);
# print $stylesheet, "\n";
my @styles = split (/;\}[\n\r]*/s, $stylesheet);

my %f_estyle;
my $style_id;
my $normal_sty_id;

for my $style (@styles) {
	$style =~ s/\n//g;
	($style_id) = $style =~ /(s\d+|cs\d+)/;
	if ($style =~ /nisusnoteplacement0/) {
		$f_estyle{'footnote'} = $style_id;
		my ($fnref) = $style =~ /nisusreferencestyle(\d+)/;
		$fnref = "cs" . $fnref;
		$f_estyle{'footnote_ref'} = $fnref;		
	}
	if ($style =~ /nisusnoteplacement[1-9]+/) {
		$f_estyle{'endnote'} = $style_id;
		my ($enref) = $style =~ /nisusreferencestyle(\d+)/;
		$enref = "cs" . $enref;
		$f_estyle{'endnote_ref'} = $enref;		
	}
	if ($style =~ /normal/i) {
		$normal_sty_id = $style_id;
		$normal_sty_id =~ s/^[sc]+//g;
	}
	
}

($style_id) = $styles[$#styles-1] =~ /(s\d+|cs\d+)/s;
$style_id =~ s/^[cs]+//g;

my $quoted_stylesheet;

if (! $f_estyle{'footnote'}) {
	$style_id++;
	my $footnote_style_id = $style_id;
	$f_estyle{'footnote'} = "s" . $style_id;
	$style_id++;
	my $footnote_ref_style_id = $style_id;
	$f_estyle{'footnote_ref'} = "cs" . $style_id;
	$footnote_style =~ s/00/$footnote_style_id/;
	$footnote_style =~ s/11/$footnote_ref_style_id/;
	$footnote_ref_style =~ s/00/$footnote_ref_style_id/;
	if ($normal_sty_id) {
		$footnote_style =~ s/22/$normal_sty_id/;
	}
	else {
		$footnote_style =~ s/\sbasedon22 //;
	}
	$quoted_stylesheet = quotemeta ($stylesheet);
	$stylesheet =~ s/\}$/${footnote_style}\n${footnote_ref_style}\n}/s;
	$rtfheader =~ s/$quoted_stylesheet/$stylesheet/s;
}
if (! $f_estyle{'endnote'}) {
	$style_id++;
	my $endnote_style_id = $style_id;
	$f_estyle{'endnote'} = "s" . $style_id;
	$style_id++;
	my $endnote_ref_style_id = $style_id;
	$f_estyle{'endnote_ref'} = "cs" . $style_id;
	$endnote_style =~ s/00/$endnote_style_id/;
	$endnote_style =~ s/11/$endnote_ref_style_id/;
	$endnote_ref_style =~ s/00/$endnote_ref_style_id/;
	if ($normal_sty_id) {
		$endnote_style =~ s/22/$normal_sty_id/;
	}
	else {
		$endnote_style =~ s/\sbasedon22 //;
	}
	$quoted_stylesheet = quotemeta ($stylesheet);
	$stylesheet =~ s/\}$/${endnote_style}\n${endnote_ref_style}\n}/s;
	$rtfheader =~ s/$quoted_stylesheet/$stylesheet/s;
}

		
# print "footnote = $f_estyle{'footnote'}\nfootnote_ref = $f_estyle{'footnote_ref'}\nendnote = $f_estyle{'endnote'}\nendnote_ref = $f_estyle{'endnote_ref'}\n";

#  exit;

$_ = $rtfdata;

s/(\\$f_estyle{'endnote_ref'} )([\\a-z0-9- ]*?{\\footnote )(\\ftnalt )([\\a-z0-9- ]*?)(\\$f_estyle{'endnote'} )([{\\a-z0-9- ]*?)(\\$f_estyle{'endnote_ref'} )/\\$f_estyle{'footnote_ref'} $2_conv_$4\\$f_estyle{'footnote'} $6\\$f_estyle{'footnote_ref'} /sg; # add "_conv_" as dummy!

# s/\\$f_estyle{'endnote_ref'}/\\$f_estyle{'footnote_ref'}/sg;
# s/\\$f_estyle{'endnote'}/\\$f_estyle{'footnote'}/sg;
# s/(\\footnote )(\\ftnalt )/$1/sg;
# endnotes -> footnotes

s/(\\$f_estyle{'footnote_ref'} )([\\a-z0-9\- ]*?{\\footnote )([\\a-z0-9\- ]*?)(\\$f_estyle{'footnote'} )([{\\a-z0-9\- ]*?)(\\$f_estyle{'footnote_ref'} )/\\$f_estyle{'endnote_ref'} $2\\ftnalt $3\\$f_estyle{'endnote'} $5\\$f_estyle{'endnote_ref'} /sg;

# s/\\$f_estyle{'footnote_ref'}/\\$f_estyle{'endnote_ref'}/sg;
# s/\\$f_estyle{'footnote'}/\\$f_estyle{'endnote'}/sg;
# s/(\\footnote )/$1\\ftnalt /sg;
# footnotes -> endnotes

s/\\footnote _conv_/\\footnote /sg; # remove dummy "_conv_"

print $rtfheader . $_;
exit;


########

sub extract_rtf_token {
	my $keyword = shift;
	my $str = shift;
	
	if (! $str) {
		return ("");
	}

	my $res;

	my $num = $str =~ s/^(.*?)(\{\\$keyword.+)$/$2/s;
	if (! $num || ! $str) {
#		die ("sub extract_rtf_token couldn't find the keyword...");
		return ("");
	}

	my $pat = '.*?\}';
	($res) = $str =~/^($pat)/s;
	if (! $res) {
		die ("sub extract_rtf_token couldn't find the matching close brace...");
	}
	my $temp = $res;
	my $temp2 = $temp;
	if ($temp =~ s/\{//sg == $temp2 =~ s/\}//sg) {
		return $res;
	}
	else {
		$num = 0;
		while (1) {
			$num++;
			my $pat2 = $pat x $num;
			($res) = $str =~/^(\{$pat2)/s;
			if (! $res) {
				die ("sub extract_rtf_token couldn't find the matching close brace...");
			}
			$temp = $res;
			$temp2 = $temp;
			if ($temp =~ s/\{//sg == $temp2 =~ s/\}//sg) {
				return $res;
			}
		}
	}
}

